/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"fmt"
)

// DeliveryFailureReportType the model 'DeliveryFailureReportType'
type DeliveryFailureReportType string

// List of DeliveryFailureReportType
const (
	DELIVERYFAILUREREPORTTYPE_REPORT_TO_SENDER DeliveryFailureReportType = "ReportToSender"
	DELIVERYFAILUREREPORTTYPE_REPORT_TO_OWNER  DeliveryFailureReportType = "ReportToOwner"
	DELIVERYFAILUREREPORTTYPE_NO_REPORT        DeliveryFailureReportType = "NoReport"
)

// All allowed values of DeliveryFailureReportType enum
var AllowedDeliveryFailureReportTypeEnumValues = []DeliveryFailureReportType{
	"ReportToSender",
	"ReportToOwner",
	"NoReport",
}

func (v *DeliveryFailureReportType) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := DeliveryFailureReportType(value)
	for _, existing := range AllowedDeliveryFailureReportTypeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid DeliveryFailureReportType", value)
}

// NewDeliveryFailureReportTypeFromValue returns a pointer to a valid DeliveryFailureReportType
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewDeliveryFailureReportTypeFromValue(v string) (*DeliveryFailureReportType, error) {
	ev := DeliveryFailureReportType(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for DeliveryFailureReportType: valid values are %v", v, AllowedDeliveryFailureReportTypeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v DeliveryFailureReportType) IsValid() bool {
	for _, existing := range AllowedDeliveryFailureReportTypeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to DeliveryFailureReportType value
func (v DeliveryFailureReportType) Ptr() *DeliveryFailureReportType {
	return &v
}

type NullableDeliveryFailureReportType struct {
	value *DeliveryFailureReportType
	isSet bool
}

func (v NullableDeliveryFailureReportType) Get() *DeliveryFailureReportType {
	return v.value
}

func (v *NullableDeliveryFailureReportType) Set(val *DeliveryFailureReportType) {
	v.value = val
	v.isSet = true
}

func (v NullableDeliveryFailureReportType) IsSet() bool {
	return v.isSet
}

func (v *NullableDeliveryFailureReportType) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDeliveryFailureReportType(val *DeliveryFailureReportType) *NullableDeliveryFailureReportType {
	return &NullableDeliveryFailureReportType{value: val, isSet: true}
}

func (v NullableDeliveryFailureReportType) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDeliveryFailureReportType) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
